/* Sample Ikon Application
*
*	COMPILE: makeapp test
*		-OR-
*	gcc -c test.c -otest.o
*	dxegen test.app _mod_init test.o
*
*/
#include <ikon.h>          /* ikon.h should ALWAYS be first */
#include <gui.h>	/* needed for gui routines */

static void appmain();
int pid;                        /* The pid Ikon sends us */
int ourwinid;           //id for our window
BITMAP *winbmp;
BITMAP *sprite1;
BITMAP *playersprite;
BITMAP *bg;
FONT *go;		//game over font
int scancode;
int _quit;
int bdelay;		//delay for baddy firing
int bomb;		//object id for the bomb
int baddy;		//object id for baddy
int score;

#define player 1
#define MAXOBJECTS 30
typedef struct objs OBJS;               //desktop icons
struct objs{
        int used;
	BITMAP *bmp;
	int x;
	int y;
	int visible;
	int speed;		//how many pixels it moves
	int offscreen;		//is the object off the screen
	int direction;		//direction object is moving	1 up - 2 right - 3 down - 4 left
};
OBJS object[MAXOBJECTS];
//****************************************************************
// You can skip over this stuff. This stuff only needs to be
// modified if you are making a DLL.
//****************************************************************
void *var_router(DCM *dcm, int function)
{
  return(0);
}

//*******************************************************************

void ExitHandler(int data)
{
	int cnt;
	cnt=0;
        if(data==0)
        {
		destroy_font(go);
		_quit=1;
		do{
			if(object[cnt].used==1)
				destroy_bitmap(object[cnt].bmp);
			cnt++;
			if(cnt>MAXOBJECTS)
				break;
		}while(1);
                CloseWin(ourwinid);	//close our window
                ExitApp(pid);		//exit the application
        }

};

int collision(int id1,int id2)
{
	//check if a collision between two objects
	if(object[id1].offscreen==1 || object[id2].offscreen==1)
		return;
	if(object[id1].used==0 || object[id2].used==0)
		return 0;
	if(object[id1].x>object[id2].x+object[id2].bmp->w)
		return 0;
	if(object[id1].y>object[id2].y+object[id2].bmp->h)
		return 0;
	if(object[id1].x+object[id1].bmp->w<object[id2].x)
		return 0;
	if(object[id1].y+object[id1].bmp->h<object[id2].y)
		return 0;
	return 1;
}

void destroy_object(int id)
{
	if(object[id].used==1)
	{

		object[id].used=0;
		destroy_bitmap(object[id].bmp);
	}
}

void move_objects()
{
	int cnt;
	int w;
	int h;
	cnt=0;
	do{
		if(object[cnt].used==1 && object[cnt].visible==1)
		{
			if(object[cnt].direction==1)
				object[cnt].y-=object[cnt].speed;
			if(object[cnt].direction==2)
				object[cnt].x+=object[cnt].speed;
			if(object[cnt].direction==3)
				object[cnt].y+=object[cnt].speed;
			if(object[cnt].direction==4)
				object[cnt].x-=object[cnt].speed;
			if(object[cnt].x<1)
				object[cnt].offscreen=1;
			if(object[cnt].y<1)
				object[cnt].offscreen=1;
			if(object[cnt].y+object[cnt].bmp->h>395)
				object[cnt].offscreen=1;
			if(object[cnt].x+object[cnt].bmp->w>490)
				object[cnt].offscreen=1;
			w=object[cnt].bmp->w;
			h=object[cnt].bmp->h;
			if(object[cnt].offscreen!=1)
				masked_blit(object[cnt].bmp,winbmp,0,0,object[cnt].x,object[cnt].y,w,h);
		}
		cnt++;
		if(cnt>MAXOBJECTS)
			break;
	}while(1);
}

int create_object(int x,int y,char *bmpfile,int visible)
{
	int cnt;
	cnt=0;
	do{
		if(object[cnt].used==0)
		{
			object[cnt].used=1;
			object[cnt].x=x;
			object[cnt].y=y;
			object[cnt].offscreen=0;
			object[cnt].visible=visible;
			object[cnt].bmp=load_bitmap(bmpfile,0);
			return cnt;
		}
		cnt++;
		if(cnt>MAXOBJECTS)
			return 0;
	}while(1);

}

void reverse_direction(int id)
{
	if(object[id].direction==1)
	{
		object[id].direction=3;
		return;
	}
	if(object[id].direction==2)
	{
		object[id].direction=4;
		return;
	}
	if(object[id].direction==3)
	{
		object[id].direction=1;
		return;
	}
	if(object[id].direction==4)
	{
		object[id].direction=2;
		return;
	}

}

void update_baddy()
{
	int cnt;
	if(object[baddy].offscreen==1)
		reverse_direction(baddy);
	object[baddy].offscreen=0;
	bdelay++;
	if(bdelay>100 && object[bomb].offscreen==1)
	{
		object[bomb].x=object[baddy].x+10;
		object[bomb].y=object[baddy].y+10;
		object[bomb].offscreen=0;
		object[bomb].visible=1;
		object[bomb].direction=3;
		object[bomb].speed=7;
		bdelay=0;
	}
	if(object[bomb].offscreen==1)
		object[bomb].visible=0;
}

void update(int data)
{
	int temp;
	int key;
	key=0;
	if(_quit==1)
		return;	//stop events
	if(CurrentWindow()!=ourwinid)
	{
		GenEvent(update,0);
		return;
	}
	key=GetKey();
	if(key!=0)
	{
		scancode=(key >> 8);
		if(scancode==KEY_RIGHT)
			object[player].x+=5;
		if(scancode==KEY_LEFT)
			object[player].x-=5;
		if(object[player].x<1)
			object[player].x=1;
		if(object[player].x+object[player].bmp->w>480)
			object[player].x=480;

	}
	blit(bg,winbmp,0,0,1,20,bg->w,bg->h);
	move_objects();
	update_baddy();
	if(collision(bomb,player)==1)
	{
		//make a beep or something
		score++;
		object[bomb].offscreen=1;
	}
	textprintf(winbmp,go,3,20,makecol(0xff,0xff,0xff),"Apples: %i",score);
	RefreshWin(ourwinid);
	GenEvent(update,0);
}

static void appmain()	//called appmain, not main!!!
{
  //*********[ Your main program routine ]****************
	char buff[100];
        InitGUI();	//initializes pointers to gui procedures and functions
			//see gui.h to see what it does

	//now we'll make a blank window with 'Hello World' as the caption	
	//ExitHandler is a pointer to the function above, it is called
	//when a user clicks the 'X' in the top right of the window.
        ourwinid=MakeWindow(10,10,503,400,"Demo Game",ExitHandler,0);
	winbmp=GetWinBMP(ourwinid);
	bg=load_bitmap("programs\\game\\bg.jpg",0);
	_quit=0;
	playersprite=load_bitmap("programs\\game\\pika.bmp",0);
	object[player].bmp=playersprite;
	object[player].x=20;
	object[player].y=390-object[player].bmp->h;
	object[player].visible=1;
	object[player].used=1;
	baddy=create_object(50,32,"programs\\game\\baddy.bmp",1);
	object[baddy].direction=2;
	object[baddy].speed=3;
	object[baddy].offscreen=0;
	bomb=create_object(50,20,"programs\\game\\bomb.bmp",0);
	object[bomb].direction=3;
	object[bomb].speed=7;
	object[bomb].offscreen=1;
	go=load_ttf_font("fonts\\serif-b.ttf",16,1);
	//show our window and wait for events
        RefreshWin(ourwinid);
	GenEvent(update,0);
};



